  [![Issues][issues-shield]][issues-url]
  [![Issues][closed-issues-shield]][closed-issues-url]
  [![GNU General Public License v3.0][license-shield]][license-url]


<!-- PROJECT LOGO -->
<br/>
<div align="center">
    <img
     src="https://raw.githubusercontent.com/mrdrzit/Behavython/main/logo/logo.png"
     style="max-width: 100%; height: 100%;"
     alt="Behavython software"

  <p align="center">
    <span style="font-size:14px">To be used in conjunction with <a href=https://bonsai-rx.org>Bonsai-RX</a> to extract behavior from video </span>
    <br />
    ·
    <a href="https://github.com/mrdrzit/Behavython/issues">Report Bug</a>
    ·
    <a href="https://github.com/mrdrzit/Behavython/issues">Request Feature</a>
  </p>
</div>



<!-- TABLE OF CONTENTS -->

  <summary>Table of Contents</summary>
  <ol>
    <li>
      <a href="#about">About the project</a>
      <ul>
        <li><a href="#built-with">Built With</a></li>
      </ul>
    </li>
    <li>
      <a href="#getting-started">Getting Started</a>
      <ul>
        <li><a href="#prerequisites">Prerequisites</a></li>
        <li><a href="#installation">Installation</a></li>
      </ul>
    </li>
    <li><a href="#usage">Usage</a></li>
    <li><a href="#contributing">Contributing</a></li>
    <li><a href="#license">License</a></li>
    <li><a href="#contact">Contact</a></li>
    <li><a href="#acknowledgments">Acknowledgments</a></li>
  </ol>




<!-- ABOUT THE PROJECT -->
<br/>

### About
- <span style="font-size:14px">This software was developed to be used in conjunction with <a href=https://bonsai-rx.org>Bonsai-RX</a> to extract behavior from video. It is a simple interface that allows the user to select the data and image files that were generated by Bonsai and then run the analysis. The results are saved in a csv file that can be used for further analysis. </span>
- <span style="font-size:14px">The software also implements bindings to the <a href=https://github.com/DeepLabCut/DeepLabCut>DeepLabCut</a> package, allowwing users to run the analysis using pretrained models on their data. </span>

### Built With

* [Python](https://www.python.org/)
* [Qt Designer](https://doc.qt.io/qt-5/qtdesigner-manual.html)


<!-- GETTING STARTED -->
## Getting Started

### Prerequisites

  - deeplabcut
  - seaborn
  - pyside6
  - openpyxl
  - scikit-image
  - pandas
  - numpy
  - matplotlib
  - tk
  - scipy

***For a simple way to keep up to date with requirements, reference the requirements.txt file***
### Installation as a pip package 
For the installation you need a simple command that you can get by one of two ways: 

 1. Copying and pasting from here:
	- "pip install behavython" (without quotation[""] marks)
 2. Going to the Pypi site and copying from there:
   	- [PyPi frontpage](https://pypi.org/project/behavython/)

_At the moment, Behavython was mainly tested on Windows_
<br/>
<!-- USAGE EXAMPLES -->
## Usage
                                
- Windows

 1. Open the interface typing "behavython" on the command line
 	- If you installed it as a pip package you can just type "behavython" on the command line
 	- If you downloaded the source code you need to go to the folder where you downloaded it and type "python Bbehavython_front.py" on the command line
 	
<p align="center">
  <img src="https://user-images.githubusercontent.com/83073576/184265356-f986cfba-65bf-4e18-a297-75e0f956e2dc.png" width="600" heigth="600" title="With this you'll be almost set">
</p>

 2. Select all the photo-data pairs that you want to analyze
 	- In this step is important that you don't forget to verify that you got all the bonsai files, including the data and a image of the arena that you are analyzing
 	
<p align="center">
  <img src="https://user-images.githubusercontent.com/83073576/184265915-4ed017de-3b79-4bbe-9d36-5b2c449317ad.png" width="600" heigth="600" title="Don't forget tha data files in the csv format">
</p>

3. Wait for the program to finish the analysis
 	- Currently the program looks like it freezed when running. It is expected behavior but we are looking into it. Right now you only need to wait a little bit.
 	
<p align="center">
  <img src="https://user-images.githubusercontent.com/83073576/184266129-8221c85a-a2cc-4024-9301-49e721d4477f.png" width="600" heigth="600" title="Don't forget tha data files in the csv format">
</p>

4. When finished the progress bar will show 100% and a preview of the results will be available on the right
 	
<p align="center">
  <img src="https://user-images.githubusercontent.com/83073576/184266218-3f14f4d6-f979-478e-9b36-1fe4f0631635.png" width="600" heigth="600" title="You just need to wait now:)">
</p>
             
See the [open issues](https://github.com/mrdrzit/Behavython/issues) for a full list of proposed features (and known issues).
<br/>

<!-- CONTRIBUTING -->
## Contributing

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated.** If you have a suggestion that would make this better, please fork the repo and create a pull request. You can also simply open an issue explaining what is the problem. Also, you can reach us by mail - listed at the end :)

<br/>
                                

<!-- LICENSE -->
## License

Distributed under the GNU General Public License v3.0. See `LICENSE.txt` for more information.

<br/>


<!-- CONTACT -->
## Contact

João Pedro Carvalho Moreira - mcjpedro@gmail.com<br />
Matheus Costa - matheuscosta3004@gmail.com

<br/>

<!-- ACKNOWLEDGMENTS -->
## Acknowledgments

* Flávio Mourão:<br/>
    Github: [Flávio Mourão](https://github.com/fgmourao) Twitter: [@F_Mourao_](https://twitter.com/F_Mourao_)
* Lab:<br/>
    [Núcleo de Neurociências](http://www.nnc.ufmg.br) 


### Developed at                                
Nucleo de Neurociencias - NNC<br/>
Universidade Federal de Minas Gerais - UFMG<br/>
Brazil<br/>


<!-- MARKDOWN LINKS & IMAGES -->
[issues-shield]: https://img.shields.io/github/issues/mrdrzit/Behavython
[issues-url]: https://github.com/mrdrzit/Behavython/issues
[closed-issues-shield]: https://img.shields.io/github/issues-closed/mrdrzit/Behavython?color=%2321e00b
[closed-issues-url]: https://github.com/mrdrzit/Behavython/issues?q=is%3Aissue+is%3Aclosed
[license-shield]: https://img.shields.io/github/license/mrdrzit/Behavython
[license-url]: https://github.com/mrdrzit/Behavython/blob/main/LICENSE
